% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/00-classes.R
\docType{class}
\name{DiscreteClass-class}
\alias{DiscreteClass-class}
\title{Class "DiscreteClass"}
\description{
Defines the object returned from \code{\link{mdirt}}.
}
\section{Slots}{


\describe{
    \item{\code{Call}:}{function call }
    \item{\code{Data}:}{list of data, sometimes in different forms }
    \item{\code{Options}:}{list of estimation options}
    \item{\code{Fit}:}{a list of fit information }
    \item{\code{Model}:}{a list of model-based information }
    \item{\code{ParObjects}:}{a list of the S4 objects used during estimation}
    \item{\code{OptimInfo}:}{a list of arguments from the optimization process}
    \item{\code{Internals}:}{a list of internal arguments for secondary computations (inspecting this
      object is generally not required)}
    \item{\code{vcov}:}{a matrix represented the asymtotic covariance matrix of the parameter estimates}
    \item{\code{time}:}{a data.frame indicating the breakdown of computation times in seconds}
}
}

\section{Methods}{


\describe{
   \item{print}{\code{signature(x = "DiscreteClass")} }
   \item{show}{\code{signature(object = "DiscreteClass")} }
   \item{anova}{\code{signature(object = "DiscreteClass")} }
   \item{coef}{\code{signature(x = "DiscreteClass")} }
   \item{summary}{\code{signature(object = "DiscreteClass")} }
   \item{residuals}{\code{signature(object = "DiscreteClass")} }
}
}

\author{
Phil Chalmers \email{rphilip.chalmers@gmail.com}
}
\keyword{classes}
